package com.lilosoft.api.service;

import cn.hutool.core.date.DateUtil;
import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.lilosoft.api.api.OcrApi;
import com.lilosoft.api.bean.receive.ReceiveMsgInfo;
import com.lilosoft.api.service.complexWindow.CommonData;
import com.lilosoft.api.service.complexWindow.ComplexWindowAbstract;
import com.lilosoft.core.utils.Base64Helper;
import lombok.extern.slf4j.Slf4j;
import okhttp3.ResponseBody;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import retrofit2.Response;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * 综窗处理类
 *
 * @author: zxfei
 * @date: 2023/10/29 10:51
 */

@Service
@Slf4j
public class ComplexService extends PublicService {


    @Autowired
    private OcrApi ocrApi;

    @Value("${complex.robertServerUrl:''}")
    protected String robertServerUrl;

    /**
     * 综窗申报
     */
    public String windowApply(ReceiveMsgInfo receiveMsgInfo) throws Exception {


        logger.info(JSONUtil.toJsonStr(receiveMsgInfo));
        Boolean success = receiveMsgInfo.getSuccess();

        receiveMsgInfo.getFileData().forEach(item -> {

            Response<ResponseBody> response = ocrApi.downloadFile(item.getFileUrl(), item.getFileName(), "0");

            boolean successful = response.isSuccessful();
            int code = response.code();
            if (successful && code == 200) {
                ResponseBody responseBody = response.body();
                //上传受理平台
                if (responseBody != null) {
                    try {
                        byte[] bytes = responseBody.bytes();
                    } catch (IOException e) {
                        throw new RuntimeException(e);
                    }
                }
            }


        });


        if (success) {

            ComplexWindowAbstract complexWindowAbstract = ComplexWindowAbstract.newType(receiveMsgInfo.getItemCode());
            CommonData commonData = new CommonData();
            commonData.setRobertServerUrl(robertServerUrl);
            commonData.setFileData(receiveMsgInfo.getFileData());
            complexWindowAbstract.doHandleWork(commonData);

        } else {
            log.info("预审事项未通过");
        }

        String result = "";//返回结果
        boolean check = true;//事项是否查找到，默认事项已经查找到
        return result;

    }

}
